// Generic helper functions

// Tab creation and update helpers
function newtab(u) { chrome.tabs.create( {'url':u} ); }
function updatetab(u) {
    chrome.tabs.getSelected(null, function(tab) { chrome.tabs.update(tab.id, {'url':u}); });
}

// Saner interface for json http requests
function jreq(url, f) {
    var xhr = new XMLHttpRequest();
    try {
        xhr.onreadystatechange = function(state) {
            if (xhr.readyState === 4) {
                var text = xhr.responseText;
                var js = null;
                try { // Needed because reddit returns raw html for strange urls (eg., : chrome://)
                    js = JSON.parse(text);
                } catch(e) {
                    console.log("Expected JSON from: "+url);
                }
                f(js);
            }
        };
        xhr.onerror = function(err) {
            console.log("xhr error: " + err);
        };
        xhr.open("GET", url);
        xhr.send({});
    } catch(e) {
        console.log("exception: " + e);
    }
}

// Probably should merge/refactor with above
function http_post(url, args, f) {
    var xhr = new XMLHttpRequest();
    var a = [];
    try {
        xhr.onreadystatechange = function(state) {
            if (xhr.readyState === 4) {
                console.log(xhr.readyState+"|"+xhr.status+"|"+state+"|"+xhr.responseText);
                if (f) {
                    var text = xhr.responseText;
                    f(text, xhr.status);
                }
            }
        };
        xhr.onerror = function(err) {
            console.log("xhr error: " + err);
        };
        xhr.open("POST", url);
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        for(var k in args) {
            a.push(k+"="+encodeURIComponent(args[k]));
        }
        xhr.send(a.join("&"));
    } catch(e) {
        console.log("exception: " + e);
    }
}

